<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2010 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: register.php
| Author: Nick Jones (Digitanium)
| Modified for QuickSign Panel by Fangree Productions
| Site: http://www.fangree.co.uk
| Modified by MvE Designs for xhtml validation
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "maincore.php";
require_once THEMES."templates/header.php";
include LOCALE.LOCALESET."register.php";
include LOCALE.LOCALESET."user_fields.php";

if (iMEMBER || !$settings['enable_registration']) { redirect("index.php"); }

if (file_exists(INFUSIONS."quicksign_panel/locale/".$settings['locale']."/register.php")) {
	include INFUSIONS."quicksign_panel/locale/".$settings['locale']."/register.php";
} else {
	include INFUSIONS."quicksign_panel/locale/English/register.php";
}
add_to_head("<link rel='stylesheet' href='".INFUSIONS."quicksign_panel/quicksign.css' type='text/css' media='screen' />");

if (isset($_GET['activate'])) {
	if (!preg_check("/^[0-9a-z]{32}$/", $_GET['activate'])) { redirect("index.php"); }
	$result = dbquery("SELECT * FROM ".DB_NEW_USERS." WHERE user_code='".$_GET['activate']."'");
	if (dbrows($result)) {
	$data = dbarray($result);
	$user_info = unserialize($data['user_info']);
	$user_status = $settings['admin_activation'] == "1" ? "2" : "0";
	
	$profile_method = "validate_insert"; $db_fields = ""; $db_values = "";
	$result = dbquery(
	"SELECT * FROM ".DB_USER_FIELDS." tuf
	INNER JOIN ".DB_USER_FIELD_CATS." tufc ON tuf.field_cat = tufc.field_cat_id
	ORDER BY field_cat_order, field_order"
	);
	if (dbrows($result)) {
	while($data = dbarray($result)) {
	if (file_exists(LOCALE.LOCALESET."user_fields/".$data['field_name'].".php")) {
	include LOCALE.LOCALESET."user_fields/".$data['field_name'].".php";
	}
	if (file_exists(INCLUDES."user_fields/".$data['field_name']."_include.php")) {
	include INCLUDES."user_fields/".$data['field_name']."_include.php";
	}
	}
	}
	
	$result = dbquery("INSERT INTO ".DB_USERS." (user_name, user_password, user_admin_password, user_email, user_hide_email, user_avatar, user_posts, user_threads, user_joined, user_lastvisit, user_ip, user_rights, user_groups, user_level, user_status".$db_fields.") VALUES('".$user_info['user_name']."', '".$user_info['user_password']."', '', '".$user_info['user_email']."', '".$user_info['user_hide_email']."', '', '0', '0', '".time()."', '0', '".USER_IP."', '', '', '101', '$user_status'".$db_values.")");
	$result = dbquery("DELETE FROM ".DB_NEW_USERS." WHERE user_code='".$_GET['activate']."'");	
	add_to_title($locale['global_200'].$locale['401']);
	opentable($locale['401']);
	if ($settings['admin_activation'] == "1") {
	echo "<div style='text-align:center'><br />\n".$locale['455']."<br /><br />\n".$locale['453']."<br /><br />\n</div>\n";
	} else {
	echo "<div style='text-align:center'><br />\n".$locale['455']."<br /><br />\n".$locale['452']."<br /><br />\n</div>\n";
	}
	closetable();
	} else {
	redirect("index.php");
	}
} elseif (isset($_POST['register'])) {
	if ($settings['display_validation'] == "1") {
	include_once INCLUDES."securimage/securimage.php";
	}
	$error = ""; $db_fields = ""; $db_values = "";

	$username = stripinput(trim(preg_replace("/ +/i", " ", $_POST['username'])));
	$email = stripinput(trim(preg_replace("/ +/i", "", $_POST['email'])));
	$password1 = stripinput(trim(preg_replace("/ +/i", "", $_POST['password1'])));
	if ($username == "" || $password1 == "" || $email == "") {
	$error .= $locale['402']."<br />\n";
	}

	if (!preg_match("/^[-0-9A-Z_@\s]+$/i", $username)) {
	$error .= $locale['403']."<br />\n";
	}

	if (preg_match("/^[0-9A-Z@]{6,20}$/i", $password1)) {
	if ($password1 != $_POST['password2']) $error .= $locale['404']."<br />\n";
	} else {
	$error .= $locale['405']."<br />\n";
	}

	if (!preg_match("/^[-0-9A-Z_\.]{1,50}@([-0-9A-Z_\.]+\.){1,50}([0-9A-Z]){2,4}$/i", $email)) {
	$error .= $locale['406']."<br />\n";
	}

	$email_domain = substr(strrchr($email, "@"), 1);
	$result = dbquery("SELECT * FROM ".DB_BLACKLIST." WHERE blacklist_email='$email' OR blacklist_email='$email_domain'");
	if (dbrows($result) != 0) { $error = $locale['411']."<br />\n"; }

	$result = dbquery("SELECT * FROM ".DB_USERS." WHERE user_name='$username'");
	if (dbrows($result) != 0) { $error = $locale['407']."<br />\n"; }

	$result = dbquery("SELECT * FROM ".DB_USERS." WHERE user_email='$email'");
	if (dbrows($result) != 0) { $error = $locale['408']."<br />\n"; }

	if ($settings['email_verification'] == "1") {
	$result = dbquery("SELECT * FROM ".DB_NEW_USERS);
	while ($new_users = dbarray($result)) {
	$user_info = unserialize($new_users['user_info']); 
	if ($new_users['user_email'] == $email) { $error = $locale['409']."<br />\n"; }
	if ($user_info['user_name'] == $username) { $error = $locale['407']."<br />\n"; break; }
	}
	}

	if ($settings['display_validation'] == "1") {
	$securimage = new Securimage();
	if (!isset($_POST['captcha_code']) || $securimage->check($_POST['captcha_code']) == false) {
	$error .= $locale['410']."<br />\n";
	}
	}

	$user_hide_email = isnum($_POST['user_hide_email']) ? $_POST['user_hide_email'] : "1";

	if ($settings['email_verification'] == "0") {
	$user_offset = isset($_POST['user_offset']) ? is_numeric($_POST['user_offset']) ? $_POST['user_offset'] : "0" : "0";
	$profile_method = "validate_insert"; $db_fields = ""; $db_values = "";
	$result = dbquery(
	"SELECT * FROM ".DB_USER_FIELDS." tuf
	INNER JOIN ".DB_USER_FIELD_CATS." tufc ON tuf.field_cat = tufc.field_cat_id
	ORDER BY field_cat_order, field_order"
	);
	if (dbrows($result)) {
	while($data = dbarray($result)) {
	if (file_exists(LOCALE.LOCALESET."user_fields/".$data['field_name'].".php")) {
	include LOCALE.LOCALESET."user_fields/".$data['field_name'].".php";
	}
	if (file_exists(INCLUDES."user_fields/".$data['field_name']."_include.php")) {
	include INCLUDES."user_fields/".$data['field_name']."_include.php";
	}
	}
	}
	}

	if ($error == "") {
	if ($settings['email_verification'] == "1") {
	require_once INCLUDES."sendmail_include.php";
	mt_srand((double)microtime()*1000000); $salt = "";
	for ($i = 0; $i <= 7; $i++) { $salt .= chr(rand(97, 122)); }
	$user_code = md5($email.$salt);
	$activation_url = $settings['siteurl']."register.php?activate=".$user_code;
	if (sendemail($username,$email,$settings['siteusername'], $settings['siteemail'], $locale['449'], $locale['450'].$activation_url)) {
	$user_info = serialize(array(
	"user_name" => $username,
	"user_password" => md5(md5($password1)),
	"user_email" => $email,
	"user_hide_email" => isnum($_POST['user_hide_email']) ? $_POST['user_hide_email'] : "1"
	));
	$result = dbquery("INSERT INTO ".DB_NEW_USERS." (user_code, user_email, user_datestamp, user_info) VALUES('$user_code', '".$email."', '".time()."', '$user_info')");
	opentable($locale['400']);
	echo "<div style='text-align:center'><br />\n".$locale['454']."<br /><br />\n</div>\n";
	closetable();
	} else {
	opentable($locale['456']);
	echo "<div style='text-align:center'><br />\n".$locale['457']."<br /><br />\n</div>\n";
	closetable();
	}
	} else {
	$user_status = $settings['admin_activation'] == "1" ? "2" : "0";
	$result = dbquery("INSERT INTO ".DB_USERS." (user_name, user_password, user_admin_password, user_email, user_hide_email, user_avatar, user_posts, user_threads, user_joined, user_lastvisit, user_ip, user_rights, user_groups, user_level, user_status".$db_fields.") VALUES('$username', '".md5(md5($password1))."', '', '".$email."', '$user_hide_email', '', '0', '0', '".time()."', '0', '".USER_IP."', '', '', '101', '$user_status'".$db_values.")");
	opentable($locale['400']);
	if ($settings['admin_activation'] == "1") {
	echo "<div style='text-align:center'><br />\n".$locale['451']."<br /><br />\n".$locale['453']."<br /><br />\n</div>\n";
	} else {
	echo "<div style='text-align:center'><br />\n".$locale['451']."<br /><br />\n".$locale['452']."<br /><br />\n</div>\n";
	}
	closetable();
	}
	} else {
	opentable($locale['456']);	
	echo "<div style='text-align:center'><br />\n".$locale['458']."<br /><br />\n$error<br />\n<a class='signup'><span>".$locale['459']."</span></a><br /></div>\n";
	echo "<p><br /></p>";
	echo "<p><br /></p>";
	echo"<div style='text-align:right;'> <a href='http://english-167720622732.spampoison.com'><img src='http://pics5.inxhost.com/images/sticker.gif' border='0' width='80' height='15' alt='' /></a><br /></div>\n";
	closetable();
	}
} else {
	if ($settings['email_verification'] == "0") {
	$offset_list = "";
	for ($i = -13; $i < 17; $i++) {
	if ($i > 0) { $offset = "+".$i; } else { $offset = $i; }
	$offset_list .= "<option".($offset == "0" ? " selected='selected'" : "").">".$offset."</option>\n";
	}
	}
	include INFUSIONS."quicksign_panel/why_register.php";
	opentable($locale['400']);	
	echo "<br /><center><a href='signup' class='signup'><span>".$locale['qr002']."</span></a></center>";
	echo "<p><br /></p>";
	echo "<div style='text-align:right;'> <a href='http://english-167720622732.spampoison.com'><img src='http://pics5.inxhost.com/images/sticker.gif' border='0' width='80' height='15' alt='' /></a><br /></div>\n";
	closetable();
	echo "<script type='text/javascript'>
	function ValidateForm(frm) {
	if (frm.username.value==\"\") {
	alert(\"".$locale['550']."\");
	return false;
	}
	if (frm.password1.value==\"\") {
	alert(\"".$locale['551']."\");
	return false;
	}
	if (frm.email.value==\"\") {
	alert(\"".$locale['552']."\");
	return false;
	}
	}
	</script>\n";

	if ($settings['enable_terms'] == 1) {
	echo "<script language='JavaScript' type='text/javascript'>
	function checkagreement() {
	if(document.inputform.agreement.checked) {
	document.inputform.register.disabled=false;
	} else {
	document.inputform.register.disabled=true;
	}
	}
	</script>";
	}
}

	require_once THEMES."templates/footer.php";
	?>